/*

    Cet exemple montre l'utilisation de l'autoboxing de types primitifs dans Java 5.
    
    
    boxing: encapsulation d'un type primitif dans une classe rfrence (wrapper):
    
    
        type primitif           wrapper
        --------------------------------
        boolean                 Boolean
        byte	                Byte
        double	                Double
        short	                Short
        int		        Integer
        long	                Long
        float	                Float
        char	                Character
    
    
    
    Avant Java 5:
    
    Si on veut crer une variable du type int ayant la valeur 0 et l'utiliser comme un objet
    
        Integer i = new Integer(0);
    
    Maintenant, il suffit de faire:
    
        Integer i = 0; boxing
        
        int j = i; unboxing
    
    
    
    Auteurs de l'exemple: McLaughlin & Flanagan
    Livre O'Reilly: Java 1.5 Tiger, A Developer's Notebook

    Commentaires supplmentaires et traduction: Mohamed Lokbani

    
    
*/


public class ConversionTester {

  public static void main(String[] args) {
    Integer i = 0;

    // Boxing
    int foo = 0;
    Integer integer = foo;

    // Simple Unboxing
    int bar = integer;

    Integer compteur = 1;        // boxing
    int compteur2 = compteur;     // unboxing

    while (true) {
      System.out.printf("Iteration %d%n", compteur++);
      if (compteur > 1000) break;
    }

    Boolean cas1 = true;
    Boolean cas2 = true;
    boolean cas3 = false;

    Boolean resultat = (cas1 || cas2) && cas3;

    Integer i1 = 256;
    Integer i2 = 256;

    if (i1 == i2) System.out.println("gaux!");
    else System.out.println("Diffrents!");

    Boolean arrive = false;
    Boolean retard = true;

    System.out.println(arrive ? (retard ? "Il tait temps!" : "Bonjour!") : 
                                  (retard ? "Autant se dpcher!" : "Au Revoir"));

    
    // De point de vue pratique, la partie de code ci-dessous ne fait rien, c'est une boucle infinie!!
    // Par contre, elle montre la capacit de Java 5 de faire des boxing/unboxing y compris dans
    // des structures de contrle, telles que if/else, while etc.
    //  noter, la possibilit maintenant d'utiliser dans un switch case, en plus de int, short, char
    // et byte; Integer, Short, Char et Byte.
    
    Integer personneDansPiece = 0;
    int CapaciteMax = 100;
    boolean tempsAvantPartir = false;
    while (personneDansPiece < CapaciteMax) {
      if (arrive) {
        System.out.println("Heureux de te revoir.");
        personneDansPiece++;
      } else {
        personneDansPiece--;
      }
      if (tempsAvantPartir) {
        do {
          System.out.printf("H, %d, lves toi!%n", personneDansPiece);
          personneDansPiece--;
        } while (personneDansPiece > 0);
      }
    }
  }
}