/*

    Si on veut passer  une mthode un nombre d'arguments qui n'est pas fix lors de
    de la dfinition, on est oblig de passer  cette mthode un tableau contenant la liste
    des arguments.
    
    Dans la version 5 de java, le concept de l'ellipse, dj disponible en C, C++ etc. a t
    ajout pour permettre de passer un nombre variable d'arguments.
    
    
    En C, C++:
    
    void affiche(int n, char c, ...)
    et on utilise les fonctions va_start, va_arg et va_end pour grer l'accs  ces arguments.
    Les arguments supplmentaires peuvent tre de types variables.
    
    En Java:
    
    Les points de suspension (...) permettent d'indiquer un nombre variable d'arguments, mais ayant
    le mme type.
    
    void affiche(int n,char... c)
    Un nombre variable d'arguments mais du type char. Les ... sont associs obligatoirement avec
    le dernier argument de la mthode. On ne peut pas voir donc [void affiche(int... n, char c)]
    
    http://java.sun.com/j2se/1.5.0/docs/guide/language/varargs.html
    
    
    Auteur: Mohamed Lokbani

    
    */

import java.util.*;

public class TestVarargs {

    public static void write(String... records) {
        for (String record: records)
            System.out.println(record);
    }

    public static void affiche(Object... mesargs) {
        // Faites attention comment vous allez manipuler par la suite mesargs
        // Au pire il faut ajouter des cast pour spcifier le type manipul
        for (Object record: mesargs)
            System.out.println(record);
    }


    public static void main(String [] args) {
    
        write("line 1");
        write("line 2", "line 3");
        write("line 4", "line 5", "line 6", "line 7", "line 8", "line 9","line 10");
    
        affiche(5);
        affiche("test");
        affiche(4.3f,2.4f,7,8.5d,"test",'A',4);
        
    }

}