/*

    Cet exemple montre comment formater l'affichage en sortie.
    
    En Java tout est objet mme le formatage en sortie. Ced qui rend la tche
    pas facile pour un programmeur dbutant.
    
    La version 5 de Java apporte des faciliter dans ce sens et permet de rejoindre
    les langages comme C et C++ dont la faon de formater les sorties.
    
    Avant (toujours disponible, et utilise)
    -1- dfinir un format
    -2- crer une instance pour fixer le format des nombres dcimaux, en utilisant -1-
    -3- fixer ou pas, le format en fonction des options rgionales (DecimalFormatSymbols)
    -4- utiliser la fonction format de la classe DecimalFormat
    
    Maintenant
    Utiliser les spcificateurs de format, introduits par le caractre %
    Utiliser la mthode printf (mme nom et format que celle utilise dans le langage C)

    http://java.sun.com/j2se/1.5.0/docs/api/java/text/DecimalFormat.html

    Auteur: Mohamed Lokbani

*/

import java.text.*;
import java.util.*;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

public class formatage {

    public static void main(String [] args){
        
        float X = 25890.3f;
        float Y = 75.44f;
        double z = 3.2;
        
        String format1 = "###0.000" ;  
        
        DecimalFormat fm1 = new DecimalFormat(format1, new DecimalFormatSymbols(Locale.US));
    
        System.out.println("X=" + fm1.format(X) + ", Y=" + fm1.format(Y));
        
        // Si vous utilisez XP FR, les options rgionales sont en Fr , pour un nombre dcimale.
        System.out.printf("%5.2f\n", X);
         // On force le programme pour utiliser options rgionales US donc . pour nombre dcimale.
        System.out.printf(Locale.US,"%5.2f\n", X);
    
    }
}

/*


XP Fr.

        >java formatage
            X=25890.301, Y=75.440
            25890,30
            25890.30
        >Exit code: 0

*/