/*
 
 
 
    En Java 1.4
    
    boolean 	add(Object o)
    Ajoute l'lment spcifi  la fin de la liste.
    
    En java tout est objet sauf les types primitifs. Pour ajouter directement un type primitif
    il fallait passer par une des classes de rfrence. Ce n'est plus le cas, comme nous l'avons
    constat avec l'exemple ConversionTester.java
    
    Ainsi, rien ne nous empche de crer maintenant une Collection de types primitifs, comme le montre
    cet exemple.
 
 
    Auteur: Mohamed Lokbani

 
 */

import java.util.*;

public class Test01 {

    @SuppressWarnings(value={"unchecked"})
    static public void main(String [] args){
        List list = new ArrayList();
        int v = 200;
        int z = 600;
        list.add(v);
        list.add(z);

        System.out.println("Liste:" + list);
    }	
	
}

/*
    La compilation de cet exemple gnre cet avertissement:

    >javac Test01.java
        Note: Test01.java uses unchecked or unsafe operations.
        Note: Recompile with -Xlint:unchecked for details.
    >Exit code: 0

    Nous devons compiler avec l'option -Xlint sans arguments pour avoir
    plus de dtails:


    >javac -Xlint Test01.java

    Test01.java:32: warning: [unchecked] unchecked call to add(E) as a member of the raw type java.util.List
        list.add(v);
                 ^

    Test01.java:33: warning: [unchecked] unchecked call to add(E) as a member of the raw type java.util.List
        list.add(z);
                 ^

    2 warnings
    
    La liste peut contenir n'importe quoi et le compilateur nous informe de cela. Nous n'avons pas prcis
    le type exact que la liste doit manipuler et il y a danger .... voir l'exemple Test02.java
    
    
    
    
*/
