/*
 
 
 
    En Java 1.4
    
    boolean 	add(Object o)
    Ajoute l'lment spcifi  la fin de la liste.
    
    En java tout est objet sauf les types primitifs. Pour ajouter directement un type primitif
    il fallait passer par une des classes de rfrence. Ce n'est plus le cas, comme nous l'avons
    constat avec l'exemple ConversionTester.java
    
    Ainsi, rien ne nous empche de crer maintenant une Collection de types primitifs, comme le montre
    cet exemple.
 
 
    Auteur: Mohamed Lokbani

 
 */

import java.util.*;


public class Test02 {
	
    static public void main(String [] args){
        List list = new ArrayList();
        int v = 200;
        int z = 600;
        list.add(v);
        list.add(z);

        String phrase = "trouble fte";
        list.add(phrase);
        System.out.println("Liste:" + list);
        
        Iterator iter = list.iterator();
        while(iter.hasNext()){
            int w = (Integer) iter.next();
            System.out.println("w:" + w);
        }
    }	
	
}

/*

        >javac -Xlint Test02.java
        Test02.java:32: warning: [unchecked] unchecked call to add(E) as a member of the raw type java.util.List
                list.add(v);
                        ^
        Test02.java:33: warning: [unchecked] unchecked call to add(E) as a member of the raw type java.util.List
                list.add(z);
                        ^
        Test02.java:36: warning: [unchecked] unchecked call to add(E) as a member of the raw type java.util.List
                list.add(phrase);
                        ^
        3 warnings



    La collection list contient n'importe quoi, pour cette raison que lors de l'appel
        iter.next() nous devons prciser le type de retour sinon erreur.

            int w = (int) iter.next();

        iter.next() retourne Object par dfaut. On ne peut pas mettre int et laisser
        l'autoboxing faire le travail!

            found   : java.lang.Object
            required: int
                    int w = (int) iter.next();
                                      ^
        Par contre on peut caster (Integer) et la l'autoboxing
                se chargera de wrapper l'integer dans un int:

                int w = (Integer) iter.next();


    Le danger de ce code rside dans cette instruction ...
    
                        int w = (int) iter.next();

            On prcise que nous allons rcuprer un lment du type int alors que nous
            avons insr un String dans list:
            
            String phrase = "trouble fte";
            list.add(phrase);
            
            
            >java Test02
                Liste:[200, 600, trouble fte]
                w:200
                w:600
                Exception in thread "main" java.lang.ClassCastException: java.lang.String
                        at Test02.main(Test02.java:40)
                >Exit code: 1

    Donc le warning voulait nous prvenir de cette utilisation problmatique. Dans l'exemple Test03.java
    nous montrons comment corriger ce warning.
*/
