/*
 
 
 
    En Java 1.4
    
    boolean 	add(Object o)
    Ajoute l'lment spcifi  la fin de la liste.
    
    En java tout est objet sauf les types primitifs. Pour ajouter directement un type primitif
    il fallait passer par une des classes de rfrence. Ce n'est plus le cas, comme nous l'avons
    constat avec l'exemple ConversionTester.java
    
    Ainsi, rien ne nous empche de crer maintenant une Collection de types primitifs, comme le montre
    cet exemple.
 
 
    En Java 1.5
    
    boolean 	add(E o)
    Ajoute l'lment spcifi  la fin de la liste.
   
    Vous remarquez ici qu'il ne s'agit plus d'un argument de type Object mais E. E tant un type "gnrique".
    
    
 
 
    Auteur: Mohamed Lokbani
 
 */

import java.util.*;


public class Test04 {
	
    static public void main(String [] args){
        List<Integer> list = new ArrayList<Integer>();
        int v = 200;
        int z = 600;
        list.add(v);
        list.add(z);

        System.out.println("Liste:" + list);
        
        Iterator<Integer> iter = list.iterator();
        while(iter.hasNext()){
            int w = iter.next();
            System.out.println("w:" + w);
        }
    }	
	
}

/*

    Est-ce qu'on peut retirer pour autant le cast de

            int w = (Integer) iter.next();

    La rponse du compilateur:

        >javac Test04.java
            Test04.java:48: incompatible types
            found   : java.lang.Object
            required: int
                        int w = iter.next();
                                         ^
            1 error
        >Exit code: 1

    Ce n'est pas parce que nous utilisons des listes gnriques que c'est possible de retirer le cast.

    Y-aurait-il une autre faon de le faire? La rponse est oui:
    
    Il suffit de prciser le type manipuler par l'itrateur iter, comme suit:
    
        Iterator<Integer> iter = list.iterator();

        iter sait qu'il ne manipule que des Integer. Ainsi l'appel suivant

            iter.next();

            retourne obligatoirement un Integer.
        
    Est ce qu'on peut utiliser une autre forme d'itrateur? Voir exemple Test05.java

*/
